#include "Fonctions.h"

/*
A une séance d’une activité donnée correspond un certain nombre de
points.
Exemple :
Une séance de musculation : 10 points
Une séance d’aquagym : 15 points
Une séance de SPA : 12 points

A chaque entrée au centre, un adhérent peut choisir une ou plusieurs activités en même temps. Il peut
par exemple faire une séance de musculation suivie d’une séance de SPA, sa carte se verra débiter de
22 points.
Attribution de points lors d'un sceance qui dépende de critères socioprofessionnels (retraités, étudiants, ...  AGE

Creditation obligatoire lors de creation adherent

Votre application doit pouvoir interdire à un adhérent de fréquenter le centre plus d’une fois par jour



*/

void GestionMenus(void)
{
    int tNoCarte[20] = {0}, tAge[20] = {0}, tPointsCarte[20] = {0}, tCarteActive[20] = {0};
    int tDate[20] = {0}, tNbActivitesJour[20] = {0};
    int tMax = 20, nbElem, choix, pasAct;
    char choixA;
    nbElem = Ouverture(tNoCarte, tAge, tPointsCarte, tCarteActive, tNbActivitesJour, tDate, tMax, &pasAct);
    if (nbElem < 0)
    {
        printf("Erreur d'ouverture du fichier ou tableau plein !!!\n");
        return;
    }
    choix = ChoixMenu();
    while (choix != 8)
    {
        if (choix == 1)
        {
            choixA = ChoixMenuAffichage();
            while (choixA != 'F' && choixA != 'f')
            {
                if (choixA == 'A' || choixA == 'a')
                {
                    Affichage1Adherent(tNoCarte, tAge, tPointsCarte, tCarteActive, nbElem);
                }
                if (choixA == 'B' || choixA == 'b')
                {
                    AffichageTousAdherents(tNoCarte, tAge, tPointsCarte, tCarteActive, nbElem);
                }
                if (choixA == 'C' || choixA == 'c')
                {
                    AffichageNbEntreesTousJour(tNbActivitesJour, tDate, nbElem);
                }
                if (choixA == 'D' || choixA == 'd')
                {
                    AffichageNbEntreesTotal(tNbActivitesJour, nbElem);
                }
                if (choixA == 'E' || choixA == 'e')
                {
                    AffichageNbAdherents(nbElem);
                }
                choixA = ChoixMenuAffichage();
            }
        }
        if (choix == 2)
        {
            nbElem = AjoutAdherent(tNoCarte, tAge, tPointsCarte, tCarteActive, tMax, nbElem);
        }
        if (choix == 3)
        {
            ModificationAge(tNoCarte, tAge, nbElem);
        }
        if (choix == 4)
        {
            nbElem = SupprimerAdherent(tNoCarte, tAge, tPointsCarte, tCarteActive, nbElem);
        }
        if (choix == 5)
        {

            AjoutPoints(tNoCarte, tPointsCarte, tCarteActive, nbElem);
        }
        if (choix == 6)
        {
            ModificationActivationCarte(tNoCarte, tCarteActive, nbElem);
        }
        if (choix == 7)
        {
            DebitActivitee(tNoCarte, tCarteActive, tNbActivitesJour, nbElem);
        }
        choix = ChoixMenu();
    }
    Sauvegarde(tNoCarte, tAge, tPointsCarte, tCarteActive, tNbActivitesJour, tDate, nbElem);
    exit(1);
}