#include "Fonctions.h"

int Ouverture(int tNoCarte[], int tAge[], int tPointsCarte[], int tCarteActive[], int tNbActivitesJour[], int tDate[], int tMax, int *pasAct)
{
    int pasMembres;
    pasMembres = OuvertureMembres(tNoCarte, tAge, tPointsCarte, tCarteActive, tMax);
    *pasAct = OuvertureActivitesJour(tNbActivitesJour, tDate, tMax);
    return pasMembres;
}

int OuvertureMembres(int tNoCarte[], int tAge[], int tPointsCarte[], int tCarteActive[], int tMax)
{
    int i = 0;
    int noCarte, age, pointsCarte, carteActive;
    FILE *flot;
    flot = fopen("membres.don", "r");
    if (flot == NULL)
    {
        printf("Problème d'ouverture du fichier membres.don en lecture.\n");
        return -1;
    }
    fscanf(flot, "%d%d%d%d", &noCarte, &age, &pointsCarte, &carteActive);
    while (!feof(flot))
    {
        if (i == tMax)
        {
            printf("Tableau plein.\n");
            fclose(flot);
            return -1;
        }
        tNoCarte[i] = noCarte;
        tAge[i] = age;
        tPointsCarte[i] = pointsCarte;
        tCarteActive[i] = carteActive;
        fscanf(flot, "%d%d%d%d", &noCarte, &age, &pointsCarte, &carteActive);
        i++;
    }
    fclose(flot);
    return i;
}

int OuvertureActivitesJour(int tNbActivitesJour[], int tDate[], int tMax)
{
    int i = 0;
    int date, nbActivitesJour;
    FILE *jour;
    jour = fopen("ActivitesJour.don", "r");
    if (jour == NULL)
    {
        printf("Problème d'ouverture du fichier ActivitesJour.don en lecture.\n");
        return -1;
    }
    fscanf(jour, "%d%d", &date, &nbActivitesJour);
    while (!feof(jour))
    {
        if (i == tMax)
        {
            printf("Tableau plein.\n");
            fclose(jour);
            return -1;
        }
        tDate[i] = date;
        tNbActivitesJour[i] = nbActivitesJour;
        fscanf(jour, "%d%d", &date, &nbActivitesJour);
        i++;
    }
    fclose(jour);
    return i;
}